	org $1001-2
	dw  $1001
	
	dw $100B,0
	db $9E,"4109"
	db 0,0,0

; game
currX		= $B0
currY		= $B1
currColor	= $B2
followColor	= $B3
ptr		= $B4
ptrc		= $B6
stackPtr	= $B8
boardOffset	= $BA
boardW		= $BC
boardH		= $BD
maxColors	= $BE
;solve		= $BF
putchr		= $C0
putcol		= $C1
level		= $C2
slptr		= $C3

; random
rand = $CC	; 32 bits

; keyboard
keyb_ptr		= $D4
keyb_lastkey		= $D6
keyb_repeatcnt		= $D7
keyb_shift		= $D8
keyb_repeat_init	= 20	; constant
keyb_repeat		= 4	; constant

; windows
wptr	= $E0
wptrc	= $E2
winw	= $E4
winh	= $E5
winc	= $E6

; math
num1	= $F0
num2	= $F2
num3	= $F4

DrawBorder	macro	xp, yp, width, height, color
	lda #($0C00+xp+yp*40) & 255
	sta wptr
	lda #($0C00+xp+yp*40) >> 8
	sta wptr+1
	lda #width
	sta winw
	lda #height
	sta winh
	lda #color
	sta winc
	jsr draw_border
endm

FillColor	macro	xp, yp, width, height, color
	lda #($0C00+xp+yp*40) & 255
	sta wptr
	lda #($0C00+xp+yp*40) >> 8
	sta wptr+1
	lda #width
	sta winw
	lda #height
	sta winh
	lda #color
	sta winc
	jsr fill_color
endm
 
CopyTextBlock	macro textPointer, screenAddress, width, height
	lda #textPointer & 255
	sta ptr
	lda #textPointer >> 8
	sta ptr+1
	;
	lda #screenAddress & 255
	sta wptr
	lda #screenAddress >> 8
	sta wptr+1
	;
	ldx #height-1
	ldy #$00
	lda (ptr),y
	beq *+10
	sta (wptr),y
	iny
	cpy #width
	bne *-9
	;
	db $24
	iny
	tya
	jsr ptr_add
	jsr wptr_add_40
	dex
	bpl *-23
endm
	
start
	lda #$00
	sta $053B
	lda #$93
	jsr $FFD2
	;
	sei
	sta $FF3F
	;
	ldx #$02
sz1	lda $00,x
	sta savezp,x
	inx
	bne sz1
	;
	lda #$1B
	sta $FF06
	lda $FF07
	and #$40
	ora #$08
	sta $FF07
	lda #$C4
	sta $FF12
	lda #$D1
	sta $FF13
	lda #$08
	sta $FF14
	lda #$61
	sta $FF15
	sta $FF19
	;
	lda #stack & 255
	sta stackPtr
	lda #stack >> 8
	sta stackPtr+1
	;
	lda #$00
	sta menu_main
	;
	ldx #$00
nt1	lda #$30
	sta levelPercent,x
	lda #$00
	sta levelScore,x
	inx
	bne nt1
	;
	CopyTextBlock logo, $0C32, 20, 7
	;
main_menu
	jsr clearScreen
	;
	lda #menu_main & 255
	ldx #menu_main >> 8
	jsr menu
	;
	sta menu_main
	asl a
	tay
	lda main_menu_jumptable,y
	sta main_menu_jump+1
	lda main_menu_jumptable+1,y
	sta main_menu_jump+2
main_menu_jump
	jmp $FFF6
	;
main_menu_jumptable
	dw introduction
	dw level_select_menu
	dw play_random_level
	dw credits
	dw quit
	;
	;
	;
credits
	DrawBorder 5, 12, 30, 9, $3C
	FillColor 6, 13, 28, 7, $00
	CopyTextBlock textCredits, $0E0E, 28, 7
	jsr waitSpace
	;
	FillColor 6, 13, 28, 7, $00
	CopyTextBlock textCredits2, $0E0E, 28, 7
	jsr waitSpace
	jmp main_menu
	
introduction
	jsr clearScreen
	DrawBorder 4, 11, 32, 11, $3C
	FillColor 5, 12, 30, 9, $00
	;
	CopyTextBlock textIntroduction, $0DE5, 30, 9
	jsr waitSpace
	;
	FillColor 5, 12, 30, 9, $00
	CopyTextBlock textIntroduction2, $0DE5, 30, 9
	jsr waitSpace
	;
	jmp main_menu

play_random_level
	;
	; --- random level
	;
	stx levelData + 16 * 4		; x returned from menu is "true" random
	jsr GetRandom
	sta levelData + 16 * 4 + 1
	;
	lda #16
	sta level
	;
mm2a	jsr GetRandom			; random size
	and #$FE
	cmp #6
	bcc mm2a 
	cmp #15
	bcs mm2a
	sta levelData + 16 * 4 + 2
	;
mm2b	jsr GetRandom			; random color
	cmp #3
	bcc mm2b
	cmp #8
	bcs mm2b
	sta levelData + 16 * 4 + 3
	;
	jmp restart_level
	;
	; ---
	;
level_select_menu
	jsr clearScreen
	DrawBorder 7, 8, 26, 17, $3C
	FillColor 8, 10, 24, 13, $16
	;
	jsr calcTotalScore
	ldx #$04
lsm0a	lda total,x
	ora #$30
	sta $FB0,x
	dex
	bpl lsm0a
	;
	ldx #11
lsm0b	lda textTotalScore,x
	sta $FA3,x
	dex
	bpl lsm0b
	;
	lda #$76
	sta ptr
	sta ptrc
	lda #$0D
	sta ptr+1
	and #$FB
	sta ptrc+1
	;
	ldy #11
lsm0	lda textSelectLevel,y
	sta (ptr),y
	lda #$15
	sta (ptrc),y
	dey
	bpl lsm0
	;
	; ---
	;
	lda #$00
	sta level
	;
	lda #$98
	sta slptr
	lda #$0D
	sta slptr+1
	;
	lda #$C2
	sta ptr
	sta ptrc
	lda #$0D
	sta ptr+1
	and #$FB
	sta ptrc+1
	;
lsm1	ldy #$01
	ldx #$30
	lda level
	cmp #$09
	bcc lsm2
	;
	sec
	sbc #$0A
	inx
	;
lsm2	clc		; write level number
	adc #$31
	sta (ptr),y
	dey
	txa
	sta (ptr),y
	;
	lda level
	asl a
	asl a ; *4
	tax
	;
	; --- determine color
	;
	ldy #$41	; default color, gray
	lda levelPercent,x
	cmp #$31
	beq lsm6
	cmp #$30
	bne lsm5
	lda levelPercent+1,x
	cmp #$30
	bne lsm5
	lda levelPercent+2,x
	cmp #$30
	bne lsm5
	;
	db $2C
lsm5	ldy #$36	; color when percent is non-zero
	db $2C
lsm6	ldy #$15	; color when percent is 100%
	sty lsm7+1	; self-mod
	;
	ldy #$27
lsm4	lda levelPercent,x
	sta (ptr),y
lsm7	lda #$00
	sta (ptrc),y
	inx
	iny
	cpy #$2a
	bne lsm4
	;
	lda #$25
	sta (ptr),y
	dey
	lda (ptrc),y
	iny
	sta (ptrc),y
	;
	; ---
	;
	lda #$06
	jsr ptr_add
	;
	inc level
	;
	lda level
	cmp #16
	beq lsm_draw_done
	;
	cmp #4
	beq lsm3
	cmp #8
	beq lsm3
	cmp #12
	bne lsm1
	;
lsm3	lda #$60
	jsr ptr_add
	jmp lsm1
	;
	; ---
	;
lsm_draw_done
	;
	lda #$00
	sta level
	jsr slRectDraw
	;
slLoop	lda #select_level_keys & 255
	ldx #select_level_keys >> 8
	jmp keyboard
	;
restart_level
	lda level
	asl a
	asl a
	tax
	lda levelData,x
	sta rand
	lda levelData+1,x
	sta rand+1
	lda #$00
	sta rand+2
	sta rand+3
	;
	lda levelData+2,x
	sta boardW
	sta boardH
	lda levelData+3,x
	sta maxColors
	;
	jsr randomBoard
	jsr calcMaxMoves
	;
;	lda solve
;	bne sv6
	;
	jsr drawScreen
	jsr drawBoardChars
	jsr drawBoardColors
	;
	jmp main
	;
;sv6	ldy #$00
;sv7	jsr randomColor
;	clc
;	adc #$31
;	cmp $0FC3,y
;	beq sv7
;	sta $0FC4,y
;	iny
;	cpy #$23
;	bne sv7 
;	;
;	lda #$00 
;	sta autoplay+1
	;
main	jsr displayMoves
	;
	jsr displayPercent
	;
	jsr checkWin
	bcs show_menu_quit
	jsr checkLose
	bcs show_menu_quit
	;
	lda #game_keys & 255
	ldx #game_keys >> 8
	jmp keyboard
	
show_menu_quit
	lda boardOffset
	clc
	adc #$0F
	sta menu_quit_level+1
	lda boardOffset+1
	adc #$01
	adc #$0C
	sta menu_quit_level+2
	;
	lda #menu_quit_level & 255
	ldx #menu_quit_level >> 8
	jsr menu
	;
	cmp #$01
	beq smq1
	;
	jmp restart_level
	;
smq1	lda level
	cmp #16				; level 16 = random level
	beq smq2
	;
	jmp level_select_menu		; from tournament levels, go to level select menu
	;
smq2	jmp main_menu			; from random level, go back to main menu

calcTotalScore
	lda #$00
	sta total
	sta total+1
	sta total+2
	sta total+3
	sta total+4
	;
	ldy #$00			; index counter
	;
cts0	tya
	and #$03
	tax
	lda levelScore,y
	beq cts1
	;
cts2	clc
	adc total+1,x
	sta total+1,x
	cmp #10
	bcc cts1
	;
	sec
	sbc #10
	sta total+1,x
	dex
	lda #1
	bne cts2
	;
cts1	iny
	cpy #16*4
	bne cts0
	rts
	
quit
	ldx #$02
sz2	lda savezp,x
	sta $00,x
	inx
	bne sz2
	;
	jsr sync
	lda #$71
	sta $FF15
	lda #$6E
	sta $FF19
	;
	sta $FF3E
	cli
	;
	lda #$13
	jsr $FFD2
	;
	jmp $8003
	
slRectClear
	ldy #$00
	lda #$20
	sta (slptr),y
	iny
	sta (slptr),y
	iny
	sta (slptr),y
	iny
	sta (slptr),y
	iny
	sta (slptr),y
	iny
	sta (slptr),y
	;
	ldy #$28
	sta (slptr),y
	ldy #$2D
	sta (slptr),y
	ldy #$50
	sta (slptr),y
	ldy #$55
	sta (slptr),y
	;
	ldy #$78
	sta (slptr),y
	iny
	sta (slptr),y
	iny
	sta (slptr),y
	iny
	sta (slptr),y
	iny
	sta (slptr),y
	iny
	sta (slptr),y
	rts 
	
slRectDraw
	ldy #$00
	lda #$70
	sta (slptr),y
	lda #$40
	iny
	sta (slptr),y
	iny
	sta (slptr),y
	iny
	sta (slptr),y
	iny
	sta (slptr),y
	iny
	lda #$6E
	sta (slptr),y
	;
	ldy #$28
	lda #$5D
	sta (slptr),y
	ldy #$2D
	sta (slptr),y
	ldy #$50
	sta (slptr),y
	ldy #$55
	sta (slptr),y
	;
	ldy #$78
	lda #$6D
	sta (slptr),y
	lda #$40
	iny
	sta (slptr),y
	iny
	sta (slptr),y
	iny
	sta (slptr),y
	iny
	sta (slptr),y
	iny
	lda #$7D
	sta (slptr),y
	;
	rts 
	
slMoveLeft
	lda level
	beq slml1
	cmp #04
	beq slml1
	cmp #08
	beq slml1
	cmp #12
	beq slml1
	;
	jsr slRectClear
	;
	lda slptr
	sec
	sbc #$06
	sta slptr
	;
	dec level
	;
	jsr slRectDraw
	;
slml1	jmp slLoop

slMoveRight
	lda level
	cmp #03
	beq slmr1
	cmp #07
	beq slmr1
	cmp #11
	beq slmr1
	cmp #15
	beq slmr1
	;
	jsr slRectClear
	;
	lda slptr
	clc
	adc #$06
	sta slptr
	;
	inc level
	;
	jsr slRectDraw
	;
slmr1	jmp slLoop

slMoveUp
	lda level
	cmp #$04
	bcc slmu1
	;
	jsr slRectClear
	;
	lda slptr
	sec
	sbc #$78
	sta slptr
	lda slptr+1
	sbc #$00
	sta slptr+1
	;
	lda level
	sec
	sbc #$04
	sta level
	;
	jsr slRectDraw
	;
slmu1	jmp slLoop

slMoveDown
	lda level
	cmp #12
	bcs slmd1
	;
	jsr slRectClear
	;
	lda slptr
	clc
	adc #$78
	sta slptr
	lda slptr+1
	adc #$00
	sta slptr+1
	;
	lda level
	clc
	adc #$04
	sta level
	;
	jsr slRectDraw
	;
slmd1	jmp slLoop
	
calcMaxMoves
	; ( boardW + boardH ) * maxColors * 25 / 168
	lda boardW
	clc
	adc boardH
	sta num1
	;
	lda maxColors
	sta num2
	;
	lda #$00
	sta num1+1
	sta num2+1
	;
	jsr multiply
	;
	lda num3
	sta num1
	lda num3+1
	sta num1+1
	;
	lda #25
	sta num2
	lda #$00
	sta num2+1
	;
	jsr multiply
	;
	lda num3
	sta num1
	lda num3+1
	sta num1+1
	;
	lda #168
	sta num2
	lda #$00
	sta num2+1
	;
	jsr divide
	;
	lda num3
	sta num1
	lda num3+1
	sta num1+1
	;
	lda #10
	sta num2
	lda #$00
	sta num2+1
	;
	jsr divide
	;
	lda #$00
	sta moves
	lda num3
	sta moves+1
	lda num1
	sta moves+2
	;
	rts
	
sync
	lda #$CC
	cmp $FF1D
	bne *-3
	rts
	
clearScreen
	jsr sync
	;
	ldx #$E0
	lda #$20
cls2	sta $0D40,x
	sta $0E20,x
	sta $0F00,x
	;
	sta $0940,x
	sta $0A20,x
	sta $0B00,x
	dex
	bne cls2
	;
	rts
	
drawScreen
	jsr clearScreen
	;
;	ldx #$27
;	lda #$20
;ds1	sta $0FC0,x
;	dex
;	bpl ds1
	;
	lda #40			; center
	sec
	sbc boardW
	lsr a
	sec
	sbc #$01
	sta currX
	;
	ldy #8
	lda mul40_lo,y
	clc
	adc currX
	sta wptr
	lda mul40_hi,y
	adc #$0C
	sta wptr+1
	;
	; --- board offset is from corner of window
	;
	lda wptr
	clc
	adc #41
	sta boardOffset
	lda wptr+1
	adc #$00
	and #$03
	sta boardOffset+1
	;
	; --- draw the border
	;
	lda boardW
	clc
	adc #$02
	sta winw
	lda boardH
	clc
	adc #$02
	sta winh
	lda #$16
	sta winc
	sta putcol
	jsr sync
	jsr draw_border
	jsr sync
	;
	; --- right side
	; 
	lda boardOffset
	clc
	adc boardW
	sta ptr
	sta ptrc
	lda boardOffset+1
	adc #$00
	adc #$0C
	sta ptr+1
	and #$FB
	sta ptrc+1
	;
	lda #$6B
	ldy #$00
	sta (ptr),y
	iny
	lda #$40
	sta (ptr),y
	iny
	sta (ptr),y
	iny
	sta (ptr),y
	iny
	lda #$6E
	sta (ptr),y
	;
	lda #$16
	ldy #$01
	sta (ptrc),y
	iny
	sta (ptrc),y
	iny
	sta (ptrc),y
	iny
	sta (ptrc),y
	;
	; ---
	;
	ldx #$00
in1	jsr ptr_add_40
	;
	ldy #$00
	lda (ptr),y
	cmp #$7D
	beq in1c
	cmp #$20
	bne in1e
	;
	lda #$5D
	db $2C	
in1c	lda #$73
	jsr putchar
	;
in1e	txa
	clc
	adc #$31
	;
	ldy #$01
	sta (ptr),y
	iny
	lda #$3A
	sta (ptr),y
	iny
	lda #$A0
	sta (ptr),y
	iny
	lda #$5D
	sta (ptr),y
	;
	dey
	lda colors,x
	sta (ptrc),y
	iny
	lda #$16
	sta (ptrc),y
	;
	inx
	cpx maxColors
	bcc in1
	;
	; ---
	;
	jsr ptr_add_40
	;
	ldy #$00
	lda (ptr),y
	cmp #$5D
	beq in1a
	cmp #$7D
	beq in1b
	;
	lda #$6D
	db $2C
in1b	lda #$71
	db $2C
in1a	lda #$6B
	jsr putchar
	lda #$40
	sta (ptr),y
	iny
	sta (ptr),y
	iny
	sta (ptr),y
	iny
	lda #$7D
	sta (ptr),y
	;
	lda #$16
	ldy #$01
	sta (ptrc),y
	iny
	sta (ptrc),y
	iny
	sta (ptrc),y
	iny
	sta (ptrc),y
	;
	; --- left side
	;
	lda boardOffset
	sec
	sbc #$09
	sta ptr
	sta ptrc
	lda boardOffset+1
	sbc #$00
	clc
	adc #$0C
	sta ptr+1
	and #$FB
	sta ptrc+1
	;
	ldy #$00
	lda #$70
	jsr putchar
	;
	ldx #$07
	lda #$40
	sta putchr
	jsr putchars
	;
	lda #$73
	jsr putchar
	;
	jsr drawBorderDown
	;
	ldx #$00
	iny
in2	lda textMoves,x
	sta (ptr),y
	iny
	inx
	cpx #$05
	bne in2
	;
	;--
	jsr drawBorderDown
	jsr drawBorderDown
	jsr drawBorderDown
	;
	;--
	;
	ldx #$00
in4	lda textPercent,x
	sta (ptr),y
	iny
	inx
	cpx #$07
	bne in4
	;
	jsr drawBorderDown
	jsr ptr_add_40
	;
	ldy #$00
	lda #$6D
	jsr putchar
	;
	ldx #$07
	lda #$40
	sta putchr
	jsr putchars
	;
	lda (ptr),y
	cmp #$5d
	beq in4a
	lda #$71
	db $2C
in4a	lda #$73
	jsr putchar
	;
	rts
	
	; x=counter	
putchars
	lda putchr
	sta (ptr),y
	lda putcol
	sta (ptrc),y
	iny
	dex
	bne putchars
	rts
	
drawBorderDown
	jsr ptr_add_40
	;
	ldy #$00
	lda #$5D
putchar
	sta (ptr),y
	lda putcol
	sta (ptrc),y
	iny
	rts
	
ptr_add_40
	lda #40
ptr_add	clc
	adc ptr
	sta ptr
	sta ptrc
	lda ptr+1
	adc #$00
	sta ptr+1
	and #$FB
	sta ptrc+1
	rts
	
displayMoves
	lda boardOffset
	clc
	adc #$4A
	sta ptr
	sta ptrc
	lda boardOffset+1
	adc #$00
	adc #$0C
	sta ptr+1
	and #$FB
	sta ptrc+1
	;
	ldy #$02
dm1	lda moves,y
	ora #$30
	sta (ptr),y
	dey
	bpl dm1
	rts
	
decMoves
	ldx #$02
im2	lda moves,x
	sec
	sbc #$01
	sta moves,x
	cmp #$FF
	bne im1
	lda #$09
	sta moves,x
	dex
	bne im2
	;
im1	rts

checkLose
	lda moves
	bne cl1
	lda moves+1
	bne cl1
	lda moves+2
	bne cl1
	;
	; lost
	;
;lost	lda solve
;	beq cl2
;	;
;	lda $0FC0
;	cmp $0C00
;	beq clA
;	bcs cl7
;	;
;clA	lda $0FC1
;	cmp $0C01
;	beq clB
;	bcs cl7
;	;
;clB	lda $0FC2
;	cmp $0C02
;	beq cl3
;	bcs cl3
;	jmp cl3
;	;
;cl7	ldx #$27
;cl4	lda $0FC0,x
;	sta $0C00,x
;	dex
;	bpl cl4
;	jmp cl3
	;
	lda boardOffset
	clc
	adc #$21
	sta ptr
	sta ptrc
	lda boardOffset+1
	adc #$00
	adc #$0C
	sta ptr+1
	and #$FB
	sta ptrc+1
	;
	ldy #$04
cl4	lda textYouLose,y
	sta (ptr),y
	lda #$32
	sta (ptrc),y
	dey
	bpl cl4
	;
	jsr ptr_add_40
	;
	ldy #$04
cl5	lda textYouLose+5,y
	sta (ptr),y
	lda #$32
	sta (ptrc),y
	dey
	bpl cl5
	;
cl2	; --- scoring when lost (score=percent)
	;
	lda #$0
	sta score
	;
	lda boardOffset
	clc
	adc #$C2
	sta ptr
	lda boardOffset+1
	adc #$00
	adc #$0C
	sta ptr+1
	;
	ldy #$00
	lda (ptr),y
	sec
	sbc #$30
	sta score+1,y
	iny
	lda (ptr),y
	sec
	sbc #$30
	sta score+1,y
	iny
	lda (ptr),y
	sec
	sbc #$30
	sta score+1,y
	;
	jsr checkScorePercent
	;
	sec
	rts
	;
cl1	clc
	rts

checkWin
	ldy #$00
cw2	ldx #$00
cw1	stx currX
	sty currY
	jsr getCurrColor
	cmp board
	bne didntwin
	;
	inx
	cpx boardW
	bne cw1
	;
	iny
	cpy boardH
	bne cw2
	;
	; --- won!
	;
	lda boardOffset
	clc
	adc #$21
	sta ptr
	sta ptrc
	lda boardOffset+1
	adc #$00
	adc #$0C
	sta ptr+1
	and #$FB
	sta ptrc+1
	;
	ldy #$04
cw3	lda textYouWin,y
	sta (ptr),y
	lda #$35
	sta (ptrc),y
	dey
	bpl cw3
	;
	jsr ptr_add_40
	;
	ldy #$04
cw4	lda textYouWin+5,y
	sta (ptr),y
	lda #$35
	sta (ptrc),y
	dey
	bpl cw4
	;
	; --- scoring (1000 for finishing level, +100 for each move left over)
	;
	lda #$01
	sta score
	lda moves+2
	sta score+1
	lda #$00
	sta score+2
	sta score+3
	;
	jsr checkScorePercent
	sec
	rts
	
didntwin
	clc
	rts
	
checkScorePercent
	;
	; --- percent
	;
	lda level
	asl a
	asl a
	tax
	;
	lda boardOffset
	clc
	adc #$C2
	sta ptr
	lda boardOffset+1
	adc #$00
	adc #$0C
	sta ptr+1
	;
	ldy #$00
	lda (ptr),y
	cmp levelPercent,x
	beq csp1
	bcs csp3
	;
csp1	iny
	lda (ptr),y
	cmp levelPercent+1,x
	beq csp2
	bcs csp3
	;
csp2	iny
	lda (ptr),y
	cmp levelPercent+2,x
	beq csp4
	bcs csp3
	jmp csp4
	;
csp3	ldy #$00		; new percent is larger than previous, copy it
	lda (ptr),y
	sta levelPercent,x
	iny
	lda (ptr),y
	sta levelPercent+1,x
	iny
	lda (ptr),y
	sta levelPercent+2,x
	;
csp4	; --- score
	;
	lda level
	asl a
	asl a
	tax
	;
	lda score
	cmp levelScore,x
	beq csp1a
	bcs csp4a
	;
csp1a	lda score+1
	cmp levelScore+1,x
	beq csp2a
	bcs csp4a
	;
csp2a	lda score+2
	cmp levelScore+2,x
	beq csp3a
	bcs csp4a
	;
csp3a	lda score+3
	cmp levelScore+3,x
	beq csp5
	bcs csp4a
	jmp csp5
	;
csp4a	lda score		; new score is larger than previous, copy it
	sta levelScore,x
	lda score+1
	sta levelScore+1,x
	lda score+2
	sta levelScore+2,x
	lda score+3
	sta levelScore+3,x
	;
csp5	rts
	
displayPercent
	ldx boardW
	ldy boardH
	jsr multiply_8bit
	;
	lda num3+1
	pha
	lda num3
	pha
	;
	lda #$00
	sta num1
	sta num1+1
	;
	ldy #$00
dp2	ldx #$00
dp1	stx currX
	sty currY
	jsr getCurrColor
	cmp board
	bne notFlooded
	;
	inc num1
	;
notFlooded
	inx
	cpx boardW
	bne dp1
	;
	iny
	cpy boardH
	bne dp2
	;
	lda #100
	sta num2
	lda #$00
	sta num2+1
	;
	jsr multiply
	;
	lda num3
	sta num1
	lda num3+1
	sta num1+1
	;
	pla
	sta num2
	pla
	sta num2+1
	;
	jsr divide
	;
	; ---
	;
	lda boardOffset
	clc
	adc #$C2
	sta ptr
	sta ptrc
	lda boardOffset+1
	adc #$00
	adc #$0C
	sta ptr+1
	and #$FB
	sta ptrc+1
	;
	; ---
	;
	ldy #$00
	lda num3
	cmp #100
	bne dp3
	;
	; --- display 100 "manually"
	;
	lda #$31
	sta (ptr),y
	iny
	lda #$30
	sta (ptr),y
	bne dp6
	;
dp3	lda #$30	
	sta (ptr),y
	;
	lda num3
	sta num1
	lda num3+1
	sta num1+1
	;
	lda #10
	sta num2
	lda #$00
	sta num2+1
	;
	jsr divide
	;
	lda num3
	ora #$30
	iny
	sta (ptr),y
	;
	lda num1
	ora #$30
dp6	iny
	sta (ptr),y
	;
	; ---
	;
;	lda solve
;	beq dp4
;	;
;	ldy #$02
;dp5	lda (ptr),y
;	sta $0FC0,y
;	dey
;	bpl dp5
	;
dp4	rts
	
randomBoard
	ldy #$00
rb2	ldx #$00
	;
rb1	stx currX
	sty currY
	jsr randomColor
	jsr setBoardXY
	;
	inx
	cpx boardW
	bne rb1
	;
	iny
	cpy boardH
	bne rb2
	;
	rts
	
randomColor
	stx rc2+1
	;
rc1	jsr GetRandom
	and #$0F
	cmp maxColors
	bcs rc1
	;
rc2	ldx #$00
	rts
	
getCurrColor
	lda currY
	asl a
	asl a
	asl a
	asl a
	clc
	adc currX
	sta gcc2+1
gcc2	lda board
	rts
	
setBoardXY
	pha
	;
	stx sb1+1
	tya
	asl a
	asl a
	asl a
	asl a
	clc
sb1	adc #$00
	sta sb2+1
	;
	pla
sb2	sta board
	;
	rts
	
;drawBoardColorXY
;	sta db3+1
;	;
;	stx db1+1
;	lda mul40_lo,y
;	clc
;db1	adc #$00
;	sta db2+1
;	;
;	lda mul40_hi,y
;	adc #$00
;	adc #$08
;	sta db2+2 
;	;
;db3	lda colors
;db2	sta $1000
;	;
;	rts
;	
;drawBoardCharXY
;	sta dbc3+1
;	;
;	stx dbc1+1
;	lda mul40_lo,y
;	clc
;dbc1	adc #$00
;	sta dbc2+1
;	;
;	lda mul40_hi,y
;	adc #$00
;	adc #$0C
;	sta dbc2+2 
;	;
;dbc3	lda #$00
;dbc2	sta $1000
;	;
;	rts
	
drawBoardChars
	ldy #$00
	;
dbr2	lda mul40_lo,y
	clc
	adc boardOffset
	sta dbr1+1
	lda mul40_hi,y
	adc boardOffset+1
	adc #$0C
	sta dbr1+2
	;
	lda #$A0
	;
	ldx #$00
dbr1	sta $0C00,x
	inx
	cpx boardW
	bne dbr1
	;
	iny
	cpy boardH
	bne dbr2
	;
	rts
	
drawBoardColors
	ldy #$00
	;
dbc2	lda mul40_lo,y
	clc
	adc boardOffset
	sta dbc1+1
	lda mul40_hi,y
	adc boardOffset+1
	adc #$08
	sta dbc1+2
	;
	tya
	asl a
	asl a
	asl a
	asl a
	sta dbc0+1
	;
	ldx #$00
dbc0	lda board,x
	clc
	adc #colors & 255
	sta dbc3+1
dbc3	lda colors
dbc1	sta $0800,x
	inx
	cpx boardW
	bne dbc0
	;
	iny
	cpy boardH
	bne dbc2
	;
	rts
	
;start_solve
;	lda #$01
;	sta solve
;	jmp restart_level
;	
;autoplay
;	ldy #$00
;	cpy #$23
;	bne ap1
;	;
;	; failed!
;	jmp lost
;	;
;ap1	inc autoplay+1
;	lda $0FC4,y
;	sec
;	sbc #$31
;	jmp fill
	
fill1
	lda #$00
	db $2C
	
fill2
	lda #$01
	db $2C
	
fill3
	lda #$02
	db $2C
	
fill4
	lda #$03
	db $2C
	
fill5
	lda #$04
	db $2C
	
fill6
	lda #$05
	db $2C
	
fill7
	lda #$06
	db $2C
	
fill8
	lda #$07
	cmp maxColors
	bcc fill
	;
	; --- otherwise not available
	;
	jmp main
	
fill
	sta currColor
	cmp board
	beq already_filled
	;
	jsr decMoves
	;
	lda board
	sta followColor
	;
	ldx #$FF
	ldy #$FF
	jsr pushXY
	;
	ldx #$00
	ldy #$00
	jsr pushXY
	;
f_loop	jsr popXY
	cpx #$FF
	beq fill_done
	;
	stx currX
	sty currY
	;
	jsr getCurrColor
	cmp followColor
	bne f_loop
	;
	; --- follow in 4 directions
	;
	lda currColor
	jsr setBoardXY
	;
	ldx currX
	ldy currY
	cpx #$00
	beq noLeft
	;
	tya
	jsr pushA
	txa
	sec
	sbc #$01
	jsr pushA
	;
noLeft	cpy #$00
	beq noUp
	;
	tya
	sec
	sbc #$01
	jsr pushA
	txa
	jsr pushA
	;
noUp	inx
	cpx boardW
	beq noRight
	;
	jsr pushXY
	;
noRight	dex
	iny
	cpy boardH
	beq noDown
	;
	jsr pushXY
	;
noDown	dey
	;
	jmp f_loop	
	;
fill_done
;	lda solve
;	bne already_filled	; don't update screen to gain speed
	;
	jsr drawBoardColors
	;
already_filled
	jmp main
	
pushXY
	tya
	jsr pushA
	txa
pushA
	sty pa1+1
	ldy #$00
	sta (stackPtr),y
pa1	ldy #$00
	;
	lda stackPtr
	clc
	adc #$01
	sta stackPtr
	lda stackPtr+1
	adc #$00
	sta stackPtr+1
	;
	rts
	
popXY
	jsr popA
	tax
	jsr popA
	tay
	rts
	
popA
	lda stackPtr
	sec
	sbc #$01
	sta stackPtr
	lda stackPtr+1
	sbc #$00
	sta stackPtr+1 
	;
	sty pa2+1
	ldy #$00
	lda (stackPtr),y
	;
pa2	ldy #$00
	rts
	
	
	
;printNum
;	sta pn1+1
;	pha
;	txa
;	pha
;	;
;pn1	lda #$00
;	lsr a
;	lsr a
;	lsr a
;	lsr a
;	tax
;	lda numChars,x
;	jsr printA
;	lda pn1+1
;	and #$0F
;	tax
;	lda numChars,x
;	jsr printA
;	;
;	pla
;	tax
;	pla
;	rts
;	
;numChars
;	db "0123456789abcdef"
;	
;printA
;	sta $0F80
;	lda printA+1
;	clc
;	adc #$01
;	sta printA+1
;	lda printA+2
;	adc #$00
;	sta printA+2
;	rts
	
waitSpace
	pha
	;
ws0	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	and #$10
	bne ws0
	;
ws1	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	and #$10
	beq ws1
	;
	pla
	rts
	
null
	rts
	
	include "math.asm"
	
	include "random.asm"
	
	include "windows.asm"
	
	include "menu.asm"
	
	include "keyboard.asm"
	include "key_constants.asm"
	
colors
	db $36,$02,$45,$67,$54,$24,$48,$53
	
logo
	include "logo_hex.asm"
	
	cmap "A",1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26
textMoves
	db "MOVES"
textPercent
	db "PERCENT"
textYouWin
	db " YOU "
	db " WIN!"
textYouLose
	db " YOU "
	db "LOSE!"
textSelectLevel
	db "SELECT LEVEL"
textTotalScore
	db "TOTAL SCORE:"
textIntroduction
	;   012345678901234567890123456789
	db "WELCOME TO FLOODIT!",0
	db " ",0
	db "THE GOAL IS TO  FILL AN ENTIRE"
	db "BOARD  WITH  THE  SAME  COLOR,"
	db "USING 'FLOOD FILLS'. THE FILLS"
	db "START IN THE TOP/LEFT CORNER. "
	db " ",0
	db "TO PLAY, SIMPLY PRESS KEYS",0
	db "FROM 1-8.",0
	;
textIntroduction2
	db "PLAY  THE   TOURNAMENT  OF  16"
	db "LEVELS  TO GET  A HIGH  SCORE."
	db "EACH  LEVEL  CAN  BE  REPLAYED"
	db "UNLIMITED NUMBER OF TIMES.",0
	db " ",0
	db "OR TRY A RANDOM  LEVEL FOR FUN"
	db "(UNSCORED).",0
	db " ",0
	db "HAVE FUN!",0
	
textCredits
	db "CODED BY CSABO OF LOD, 2014."
	db " ",0
	db "IDEA FROM:",0
	db "HTTP://FLOODIT.APPSPOT.COM",0
	db " ",0
	db "THANKS TO CHRONOS FOR THE",0
	db "SUGGESTION.",0
	;
textCredits2
	db "THANKS TO LUCA, GAIA AND",0
	db "CHRONOS FOR BETA TESTING.",0
	db " ",0
	db "GREETINGS TO EVERY C16/PLUS4"
	db "FAN ALL OVER THE UNIVERSE!",0
	db " ",0
	db "KEEP THE PLUS4 ALIVE!",0
	
menu_main
	db 0
	dw $0C00 + 12 * 40 + 10
	db 20,8
	db $41,$25
	db "     -SELECT-     "
	db "   INTRODUCTION   "
	db " PLAY TOURNAMENT  "
	db "PLAY RANDOM LEVEL "
	db "     CREDITS      "
	db "       QUIT       "
	
menu_quit_level
	db 0
	dw $0C00 + 14 * 40 + 16
	db 8	; window size
	db 5
	db $32,$31	; window color
	db "SELECT"
	db "REPLAY"
	db " QUIT "
	cmap
	
game_keys
	dw null
	;
	dw KEY_1, fill1
	dw KEY_2, fill2
	dw KEY_3, fill3
	dw KEY_4, fill4
	dw KEY_5, fill5
	dw KEY_6, fill6
	dw KEY_7, fill7
	dw KEY_8, fill8
	;
	dw KEY_ESC, show_menu_quit
	;
	dw 0
	
select_level_keys
	dw null
	;
	dw KEY_CURSOR_RIGHT, slMoveRight	; cursor keys
	dw KEY_CURSOR_LEFT, slMoveLeft
	dw KEY_CURSOR_UP, slMoveUp
	dw KEY_CURSOR_DOWN, slMoveDown
	dw KEY_RETURN, restart_level
	dw KEY_ESC, main_menu
	dw 0
	
mul40_lo
	db 0*40 & 255
	db 1*40 & 255
	db 2*40 & 255
	db 3*40 & 255
	db 4*40 & 255
	db 5*40 & 255
	db 6*40 & 255
	db 7*40 & 255
	db 8*40 & 255
	db 9*40 & 255
	;
	db 10*40 & 255
	db 11*40 & 255
	db 12*40 & 255
	db 13*40 & 255
	db 14*40 & 255
	db 15*40 & 255
	db 16*40 & 255
	db 17*40 & 255
	db 18*40 & 255
	db 19*40 & 255
	;
	db 20*40 & 255
	db 21*40 & 255
	db 22*40 & 255
	db 23*40 & 255
	db 24*40 & 255

mul40_hi
	db 0*40 >> 8
	db 1*40 >> 8
	db 2*40 >> 8
	db 3*40 >> 8
	db 4*40 >> 8
	db 5*40 >> 8
	db 6*40 >> 8
	db 7*40 >> 8
	db 8*40 >> 8
	db 9*40 >> 8
	;
	db 10*40 >> 8
	db 11*40 >> 8
	db 12*40 >> 8
	db 13*40 >> 8
	db 14*40 >> 8
	db 15*40 >> 8
	db 16*40 >> 8
	db 17*40 >> 8
	db 18*40 >> 8
	db 19*40 >> 8
	;
	db 20*40 >> 8
	db 21*40 >> 8
	db 22*40 >> 8
	db 23*40 >> 8
	db 24*40 >> 8
	
levelData
	db $19,$72,14,6
	db $27,$2D,12,6
	db $90,$5A,10,5
	db $FF,$F0, 6,4
	
	db $39,$85,14,6
	db $33,$02,12,6
	db $91,$17,10,5
	db $D4,$0C, 6,3
	
	db $44,$01,14,5
	db $07,$07,12,5
	db $1D,$21,10,4
	db $33,$10, 8,8
	
	db $05,$33,14,5
	db $08,$9c,12,5
	db $E1,$EF,10,4
	db $34,$1D, 8,7
	
	db 0,0,0,0 ; level 16: random level
	
moves	= $2800
score	= $2810
total	= $2820

savezp		= $2900	
levelPercent	= $2A00
levelScore	= $2B00
board		= $2C00
stack		= $2D00
;eof